/***
   role.c
***/

#include "creddy_internal.h"

extern certificate_t *abac_attribute_cert_from_file(char *filename);
extern char* abac_decode_string(char *);

static void _get_attributes(options_t *opts) {

    certificate_t *cert = abac_attribute_cert_from_file(opts->cert);
    if(cert == NULL)
        errx(1, "Couldn't get attributes from cert");
    ac_t *ac = (ac_t *)cert;
    ietf_attributes_t *attr = ac->get_groups(ac);
    if (attr == NULL)
        errx(1, "Couldn't get attributes from cert");

    puts(abac_decode_string(attr->get_string(attr)));

    DESTROY_IF(attr);
    DESTROY_IF(cert);
}

void roles_main(options_t *opts) {
    if (opts->cert == NULL)
        usage(opts);

    _get_attributes(opts);
}

void osets_main(options_t *opts) {
    if (opts->cert == NULL)
        usage(opts);

    _get_attributes(opts);
}

