/* only valid in YAP 6.3.2, trying out YAP_WriteDynamicBuffer */

#include "util.h"


/* wrapper used to call into yap */
static int Main_Wrapper() {
    char str[100];
    int res;

    if (YAP_FastInit(NULL) == YAP_BOOT_ERROR)
        YAP_Exit(1);

    if (YAP_RunGoal(YAP_MkAtomTerm(YAP_LookupAtom("source")))) {
        printf("calling source okay..\n");
        } else {
        printf("calling source failed..\n");
        YAP_Exit(1);
    }

    _showDB(1);

//  to query : anc(Y, 'str')
    YAP_Atom anc = YAP_LookupAtom("anc");
    YAP_Functor afunc=YAP_MkFunctor(anc, 2);
    YAP_Term arg[2];
    for (;;)
        {
        printf("\nEnter a name(mark|mary|bob|jane|john) or 'end' to finish : ");
        fflush(stdout);
        scanf("%s", str);

        if (strcmp(str, "end") == 0)
            break;

        arg[0] = YAP_MkVarTerm();
        arg[1] = YAP_MkAtomTerm(YAP_LookupAtom(str));
        YAP_Term goal = YAP_MkApplTerm(afunc, 2, arg);
        long sl= YAP_InitSlot(goal);
        res = YAP_RunGoal(goal);
        char *sol;
        char sz=0;
        int lengthp=0;
        int encp=0;
        if (res) {
            printf("Success\n");
            YAP_Term argterm=YAP_ArgOfTerm(1,YAP_GetFromSlot(sl));
            char *res=YAP_WriteDynamicBuffer(argterm, sol, sz, &lengthp, &encp,YAP_WRITE_HANDLE_VARS);
            if(res!=NULL) {
                printf("    answer : %s\n", sol);
                printf("returning lengthp(%d), encp(%d), strlen(%d)\n",
                              lengthp, encp, strlen(res));
                free(sol); sol=NULL; sz=0;
            } else printf("    can not extract answer\n");
            printf("sz is (%d)\n", sz);
            while (YAP_RestartGoal()) {
                printf("Success\n");
                YAP_Term argterm=YAP_ArgOfTerm(1,YAP_GetFromSlot(sl));
                char *res=YAP_WriteDynamicBuffer(argterm, sol, sz, &lengthp, &encp,YAP_WRITE_HANDLE_VARS);
                if(res) {
                    printf("    answer : %s\n", sol);
                    printf("returning lengthp(%d), encp(%d), strlen(%d)\n",
                              lengthp, encp, strlen(res));
                    free(sol); sol=NULL; sz=0;
                } else printf("    can not extract answer\n");
                printf("sz is (%d)\n", sz);
            }
        } else printf("Failed\n");
        YAP_RecoverSlots(1);
        res=YAP_ShutdownGoal(TRUE);
    }

    return 0;
}

int main(int argc, char *argv[]) {
    return Main_Wrapper();
}
