
#include "util.h"

/*
...final principal set...
(pAcme,keyid,y)
(pAlice,keyid,y)
(pBob,keyid,y)
(pGlobotron,keyid,y)

...final policy attribute set...
pAcme.experiment_create <- pAcme.partner.experiment_create
pAcme.partner <- pGlobotron
pAlice.power_user <- pBob
pGlobotron.admin <- pAlice
pAcme.experiment_create <- pGlobotron.admin.power_user

 Acme.experiment_create <- Bob
*/


/* wrapper used to call into yap */
static int Main_Wrapper() {
    char sol[100];
    char sz=100;
    int res;
    YAP_Term goal;
    YAP_Term error;


    if (YAP_FastInit(NULL) == YAP_BOOT_ERROR)
        YAP_Exit(1);

    if (YAP_RunGoal(YAP_MkAtomTerm(YAP_LookupAtom("source")))) {
        printf("calling source okay..\n");
        } else {
        printf("calling source failed..\n");
        YAP_Exit(1);
    }

    _loadFacts("create");
    _showDB(1);

//  to query : anc(Y, 'str')
//  to query:  Acme.experiment_create <- Bob
//  extract Acme's sha, Bob's sha
// isMember(pBob,role(pAcme,experiment_create),X)
    YAP_Atom anc = YAP_LookupAtom("isMember");
    YAP_Functor afunc=YAP_MkFunctor(anc, 2);
    char str[100];
    printf("\nWho is ancester of... \n");
    for (;;)
        {
        printf("  Enter a name(mark|mary|bob|jane|john) or 'end' to finish : ");
        fflush(stdout);
        scanf("%s", str);

        if (strcmp(str, "end") == 0)
            break;

        YAP_Term arg[2];
        arg[0] = YAP_MkVarTerm();
        arg[1] = YAP_MkAtomTerm(YAP_LookupAtom(str));
        goal = YAP_MkApplTerm(afunc, 2, arg);
        long sl= YAP_InitSlot(goal);
        res = YAP_RunGoal(goal);
        if (res) {
            printf("Success\n");
            YAP_Term argterm=YAP_ArgOfTerm(1,YAP_GetFromSlot(sl));
            int res=YAP_WriteBuffer(argterm, sol, sz,YAP_WRITE_HANDLE_VARS);
            if(res==0)
                printf("    answer : %s\n", sol);
                else printf("    can not extract answer\n");
            while (YAP_RestartGoal()) {
                printf("Success\n");
                YAP_Term argterm=YAP_ArgOfTerm(1,YAP_GetFromSlot(sl));
                int res=YAP_WriteBuffer(argterm, sol, sz,YAP_WRITE_HANDLE_VARS);
                if(res==0)
                    printf("    answer : %s\n", sol);
                    else printf("    can not extract answer\n");
            }
        } else printf("Failed\n");
        YAP_RecoverSlots(1);
        res=YAP_ShutdownGoal(TRUE);
    }

    return 0;
}

int main(int argc, char *argv[]) {
    return Main_Wrapper();
}
