/****
   rocketmain.c
****/

#define _GNU_SOURCE
#include <stdio.h>
#include "util.h"

char *plist=NULL;
char *ptr=NULL;

// need to think about this case, USC.managerOf(Maryann) <- John

/*************************************************************************/
static void _build_principal_tb(char *fname)
{
    char string[1000];
    char *sptr=string;
    char nstr[100];
    int num;
    FILE *fp;
    fp=fopen(fname,"r");
    if(fp) {
        while(getline(&sptr,&num,fp)>0) {
            int v=sscanf(sptr,"isType(%s", nstr);
            int i;
            if(v) {
                for(i=0; i<100; i++) {
                    if(nstr[i]==',') {
                        nstr[i]='\0';
                        break;
                    }
                }
                ptr=plist; plist=NULL;
                if(ptr==NULL)
                    asprintf(&plist,"%s",nstr);
                    else asprintf(&plist,"%s|%s",ptr,nstr);
            }
        }
        fclose(fp);
        } else {
           printf("ERROR: can not open %s!!!\n",fname);
           exit(1);
     }
}

static void _loadFacts(char *name)
{
    YAP_Term error;

    char *cstr= (char *) malloc(sizeof(char) * (strlen(name)+10));
    sprintf(cstr,"consult(%s)",name);
    YAP_Term goal=YAP_ReadBuffer(cstr, &error);
    printf("calling consult.. \n");
    int res =YAP_RunGoal( goal );
    free(cstr);
    if (res) {
        printf("consult ok.. \n");
    } else {
        printf("consult's bad.. \n");
        YAP_Exit(1);
    }

}

/*************************************************************************/

YAP_Term _aspect_what_whom(char *aspect)
{
    /* aspect part */
    int n=2;
    YAP_Atom functor = YAP_LookupAtom(aspect);
    YAP_Functor func=YAP_MkFunctor(functor, n);
    YAP_Term *arg_ptr=(YAP_Term *)malloc(sizeof(YAP_Term)*n);
    arg_ptr[0]= YAP_MkVarTerm();
    arg_ptr[1]=YAP_MkVarTerm();
    YAP_Term ret=YAP_MkApplTerm(func, 2, arg_ptr);
/*
    YAP_Term arg[2];
    arg[0] = YAP_MkVarTerm();
    arg[1]=YAP_MkVarTerm();
    YAP_Term ret=YAP_MkApplTerm(func, 2, arg);
*/
    return ret;
}

YAP_Term _aspect_what(char *whom, char *aspect)
{
    YAP_Atom functor = YAP_LookupAtom(aspect);
    YAP_Functor func=YAP_MkFunctor(functor, 2);
    YAP_Term arg[2];
    arg[0] = YAP_MkAtomTerm(YAP_LookupAtom(whom));
    arg[1]=YAP_MkVarTerm();
    YAP_Term ret=YAP_MkApplTerm(func, 2, arg);
    return ret;
}

YAP_Term _aspect_n_what(char *whom, char *aspect, int n)
{
    YAP_Atom functor = YAP_LookupAtom(aspect);
    YAP_Functor func=YAP_MkFunctor(functor, n+1);
    YAP_Term arg[n+1];
    int i=1;
    arg[0] = YAP_MkAtomTerm(YAP_LookupAtom(whom));
    while(i<=n)
        arg[i]=YAP_MkVarTerm();
    YAP_Term ret=YAP_MkApplTerm(func, n+1, arg);
    return ret;
}

YAP_Term _aspect_whom(char *aspect, char *aspect_type)
{
    YAP_Atom functor = YAP_LookupAtom(aspect);
    YAP_Functor func=YAP_MkFunctor(functor, 2);
    YAP_Term arg[2];
    arg[0] = YAP_MkVarTerm();
    arg[1] = YAP_MkAtomTerm(YAP_LookupAtom(aspect_type));
    YAP_Term ret=YAP_MkApplTerm(func, 2, arg);
    return ret;
}

YAP_Term _aspect_fact(char *whom, char *aspect, char *aspect_type)
{
    YAP_Atom functor = YAP_LookupAtom(aspect);
    YAP_Functor func=YAP_MkFunctor(functor, 2);
    YAP_Term eterm;
    YAP_Term arg[2];
    arg[0] = YAP_MkAtomTerm(YAP_LookupAtom(whom));
    if(aspect_type[0]=='\'' || aspect_type[0]=='"') {
        arg[1]=YAP_ReadBuffer(aspect_type,&eterm);
        } else {
            arg[1] = YAP_MkAtomTerm(YAP_LookupAtom(aspect_type));
    }
    YAP_Term ret=YAP_MkApplTerm(func, 2, arg);
    return ret;
}

static int _goal_call(YAP_Term *arg) 
{
    char sol1[10000];
    char sol2[10000];
    char sol3[10000];
    int sz=10000;
    YAP_Term arg1term;
    YAP_Term arg2term;
    YAP_Term arg3term;
    int res1;
    int res2;
    int res3;

    YAP_Atom isfunctor = YAP_LookupAtom("isMember");
    YAP_Functor afunc=YAP_MkFunctor(isfunctor, 3);
    YAP_Term goal= YAP_MkApplTerm(afunc, 3, arg);
    long sl= YAP_InitSlot(goal);
    int res = YAP_RunGoal(goal);

    if (res) {
        printf("Success\n");
        arg1term=YAP_ArgOfTerm(1,YAP_GetFromSlot(sl));
        arg2term=YAP_ArgOfTerm(2,YAP_GetFromSlot(sl));
        arg3term=YAP_ArgOfTerm(3,YAP_GetFromSlot(sl));
        res1=YAP_WriteBuffer(arg1term, sol1, sz,YAP_WRITE_HANDLE_VARS);
        res2=YAP_WriteBuffer(arg2term, sol2, sz,YAP_WRITE_HANDLE_VARS);
        res3=YAP_WriteBuffer(arg3term, sol3, sz,YAP_WRITE_HANDLE_VARS);
        if(res1==0 && res2==0 && res3==0)
            printf("    answer : (%s)(%s)%s\n", sol1,sol2,sol3);
            else printf("    can not extract answer\n");
        while (YAP_RestartGoal()) {
            printf("restart Success\n");
            arg1term=YAP_ArgOfTerm(1,YAP_GetFromSlot(sl));
            arg2term=YAP_ArgOfTerm(2,YAP_GetFromSlot(sl));
            arg3term=YAP_ArgOfTerm(3,YAP_GetFromSlot(sl));
            res1=YAP_WriteBuffer(arg1term, sol1, sz,YAP_WRITE_HANDLE_VARS);
            res2=YAP_WriteBuffer(arg2term, sol2, sz,YAP_WRITE_HANDLE_VARS);
            res3=YAP_WriteBuffer(arg3term, sol3, sz,YAP_WRITE_HANDLE_VARS);
            if(res1==0 && res2==0 && res3==0)
                printf("    answer : (%s)(%s)%s\n", sol1,sol2,sol3);
                else printf("    can not extract answer\n");
        }
        YAP_RecoverSlots(1);
        } else {
            printf("Failed\n");
            YAP_RecoverSlots(1);
            return 1;
    }
    return 0;
}


/**************************************************************
x    can pLadybug buy_rockets from pAcme ? (ask_fact)
x    can pLadybug buy_rockets from Whom ? (ask_whom)
x    can pLadybug What from pAcme ? (ask_what)
x    can pLadybug What from Whom ? (ask_what_whom)

x    Who can buy_rockets from pAcme ? (ask_who)
**************************************************************/
// Whom.What <- ladybug
// isMember(ladybug, role(W1, W2), R)
static int ask_what_whom(char *who, char *aspect) {
    char str[100];

    printf("\n%s can what from whom... \n", who);
    printf("  Try again (yes) ? or'end' to finish : ");
    fflush(stdout);
    scanf("%s", str);
    if (strcmp(str, "end") == 0) {
        return 0;
    }

    YAP_Term arg[3];
    arg[0] = YAP_MkAtomTerm(YAP_LookupAtom(who));
    arg[1] = _aspect_what_whom(aspect);
    arg[2] = YAP_MkVarTerm();

    int res=_goal_call(arg);
    return res;
}

// pAcme.What <- ladybug
// isMember(ladybug, role(pAcme, W), R)
static int ask_what(char *who, char* whom, char *aspect) {
    char str[100];

    printf("\n%s can what from %s... \n", who, whom);
    printf("  Try again (yes) ? or'end' to finish : ");
    fflush(stdout);
    scanf("%s", str);
    if (strcmp(str, "end") == 0) {
        return 0;
    }

    /* outer part */
    YAP_Term arg[3];
    arg[0] = YAP_MkAtomTerm(YAP_LookupAtom(who));
    arg[1] = _aspect_what(whom,aspect);
    arg[2] = YAP_MkVarTerm();

    int res=_goal_call(arg);
    return res;
}


// W.rocket <- ladybug
// isMember(ladybug, role(W, buy_rockets), R)
static int ask_whom(char *who, char *aspect, char *aspect_type) {
    char str[100];

    printf("\n%s can %s from whom... \n", who, aspect_type);
    printf("  Try again (yes) ? or'end' to finish : ");
    fflush(stdout);
    scanf("%s", str);
    if (strcmp(str, "end") == 0) {
        return 0;
    }

    /* outer part */
    YAP_Term arg[3];
    arg[0] = YAP_MkAtomTerm(YAP_LookupAtom(who));
    arg[1] = _aspect_whom(aspect, aspect_type);
    arg[2] = YAP_MkVarTerm();

    int res=_goal_call(arg);
    return res;
}
// Acme.rocket <- V
// isMember(V, role(pAcme, buy_rockets), R)
static int ask_who(char *whom, char *aspect, char *aspect_type) {
    char str[100];

    YAP_Atom isfunctor = YAP_LookupAtom("isMember");
    YAP_Functor afunc=YAP_MkFunctor(isfunctor, 3);

    printf("\nWho else can %s from %s... \n", aspect_type, whom);
    printf("  Try again (yes) ? or 'end' to finish : ");
    fflush(stdout);
    scanf("%s", str);
    if (strcmp(str, "end") == 0) {
        return 0;
    }

    YAP_Term arg[3];
    arg[0] = YAP_MkVarTerm();
    arg[1] = _aspect_fact(whom, aspect, aspect_type);
    arg[2] = YAP_MkVarTerm();

    int res=_goal_call(arg);
    return res;
}

// Acme.rocket <- x 
// isMember(x, role(pAcme, buy_rockets), R)
static int ask_fact(char *whom, char* aspect, char *aspect_type) {
    char str[100];

    for (;;)
        {
        YAP_Atom isfunctor = YAP_LookupAtom("isMember");
        YAP_Functor afunc=YAP_MkFunctor(isfunctor, 3);
        printf("\nWho can %s from %s... \n", aspect_type, whom);
        printf("  Enter a name(%s) or 'end' to finish : ",plist);
        fflush(stdout);
        scanf("%s", str);
        if (strcmp(str, "end") == 0) {
            break;
        }
        YAP_Term arg[3];
        arg[0] = YAP_MkAtomTerm(YAP_LookupAtom(str));
        arg[1] = _aspect_fact(whom, aspect, aspect_type);
        arg[2] = YAP_MkVarTerm();

        int res=_goal_call(arg);

        if (res) {
            ask_whom(str,aspect,aspect_type);
            ask_what(str,whom,aspect);
            ask_what_whom(str,aspect);
            ask_who(whom,aspect,aspect_type);
        }
    }
    return 0;
}

/* wrapper used to call into yap */
static int Main_Wrapper() {

    if (YAP_FastInit(NULL) == YAP_BOOT_ERROR)
        YAP_Exit(1);

    if (YAP_RunGoal(YAP_MkAtomTerm(YAP_LookupAtom("source")))) {
        printf("calling source okay..\n");
        } else {
        printf("calling source failed..\n");
        YAP_Exit(1);
    }

    _loadFacts("rockets_rt0");
    _build_principal_tb("rockets_rt0.pl");

    return ask_fact("pAcme", "role", "buy_rockets");
}

int main(int argc, char *argv[]) {
    return Main_Wrapper();
}
