/****
   rocketmain.c
****/

#define _GNU_SOURCE
#include <stdio.h>
#include "util.h"

char *plist=NULL;
char *ptr=NULL;
int debug=1;

// need to think about this case, USC.managerOf(Maryann) <- John
// isMember(john, role( usc, managerof, maryann).
//          who  aspect whom what       whatwith

/*************************************************************************/
static void _build_principal_tb(char *fname)
{
    char string[1000];
    char *sptr=string;
    char nstr[100];
    int num;
    FILE *fp;
    fp=fopen(fname,"r");
    if(fp) {
        while(getline(&sptr,&num,fp)>0) {
            int v=sscanf(sptr,"isType(%s", nstr);
            int i;
            if(v) {
                for(i=0; i<100; i++) {
                    if(nstr[i]==',') {
                        nstr[i]='\0';
                        break;
                    }
                }
                ptr=plist; plist=NULL;
                if(ptr==NULL)
                    asprintf(&plist,"%s",nstr);
                    else asprintf(&plist,"%s|%s",ptr,nstr);
            }
        }
        fclose(fp);
        } else {
           printf("ERROR: can not open %s!!!\n",fname);
           exit(1);
     }
}

static void _loadFacts(char *name)
{
    YAP_Term error;

    char *cstr= (char *) malloc(sizeof(char) * (strlen(name)+10));
    sprintf(cstr,"consult(%s)",name);
    YAP_Term goal=YAP_ReadBuffer(cstr, &error);
    printf("calling consult.. \n");
    int res =YAP_RunGoal( goal );
    free(cstr);
    if (res) {
        printf("consult ok.. \n");
    } else {
        printf("consult's bad.. \n");
        YAP_Exit(1);
    }

}

/*************************************************************************/
YAP_Term _make_term(char *term) {
    YAP_Term eterm;
    YAP_Term ret;
    if(term[0]=='\'' || term[0]=='"') {
        ret =YAP_ReadBuffer(term,&eterm);
        } else {
            ret = YAP_MkAtomTerm(YAP_LookupAtom(term));
    }
}

// isMember(who,aspect(whom,what,whatwith)) 
/* aspect(whom, what, whatwith) */
YAP_Term _aspect_base(char *whom,char *aspect, char *what, char *whatwith)
{
    YAP_Term eterm;
    YAP_Term ret;

    char *estring=NULL;
    if(whatwith)
       asprintf(&estring, "%s(%s,%s,%s)",aspect,whom,what,whatwith);
       else asprintf(&estring, "%s(%s,%s)",aspect,whom,what);
    if(debug) fprintf(stderr,"_aspect_base, doing %s\n",estring);
    ret=YAP_ReadBuffer(estring,&eterm);
    free(estring);
    return ret;
}

/* generate a string of whatwith that are of ?variable */
char *_make_whatwith_var(char *whatwith)
{
/* this is a dumb count since it is in porting directory */
   if(whatwith==NULL) return NULL;  
   int len=strlen(whatwith);
   int i;
   int cnt=1;
   for(i=1;i<len;i++) {
      if(whatwith[i]==',')
         cnt++;
   }
   char *tmp=NULL;
   char *ptr=NULL;
   for(i=1;i<cnt;i++) {
       ptr=tmp;
       tmp=NULL;
       if(i != 1)
           asprintf(&tmp,"Whatwith%d",i);
           else asprintf(&tmp,",Whatwith%d",i);
   }
   return tmp;
}

/* aspect(X, Y, Whatwith) */
YAP_Term _aspect_what_whom(char *whom,char *aspect, char *what, char *whatwith)
{
    char *tmp=_make_whatwith_var(whatwith);
    YAP_Term ret=_aspect_base("Whom",aspect,"What",tmp);
    free(tmp);
    return ret;
}

/* aspect(whom,Y,Whatwith) */
YAP_Term _aspect_what(char *whom,char *aspect, char *what, char *whatwith)
{
    char *tmp=_make_whatwith_var(whatwith);
    YAP_Term ret=_aspect_base(whom,aspect,"What",tmp);
    free(tmp);
    return ret;
}

/* aspect(X,what,whatwith) */
YAP_Term _aspect_whom(char *whom,char *aspect, char *what, char *whatwith)
{
    return _aspect_base("Whom",aspect,what,whatwith);
}

/* aspect(whom,what,whatwith) */
YAP_Term _aspect_fact(char *whom,char *aspect, char *what, char* whatwith)
{
    return _aspect_base(whom,aspect,what,whatwith);
}

static int _goal_call(YAP_Term *arg) 
{
    char sol1[10000];
    char sol2[10000];
    char sol3[10000];
    int sz=10000;
    YAP_Term arg1term;
    YAP_Term arg2term;
    YAP_Term arg3term;
    int res1;
    int res2;
    int res3;

    YAP_Atom isfunctor = YAP_LookupAtom("isMember");
    YAP_Functor afunc=YAP_MkFunctor(isfunctor, 3);
    YAP_Term goal= YAP_MkApplTerm(afunc, 3, arg);
    long sl= YAP_InitSlot(goal);
    int res = YAP_RunGoal(goal);

    if (res) {
        printf("Success\n");
        arg1term=YAP_ArgOfTerm(1,YAP_GetFromSlot(sl));
        arg2term=YAP_ArgOfTerm(2,YAP_GetFromSlot(sl));
        arg3term=YAP_ArgOfTerm(3,YAP_GetFromSlot(sl));
        res1=YAP_WriteBuffer(arg1term, sol1, sz,YAP_WRITE_HANDLE_VARS);
        res2=YAP_WriteBuffer(arg2term, sol2, sz,YAP_WRITE_HANDLE_VARS);
        res3=YAP_WriteBuffer(arg3term, sol3, sz,YAP_WRITE_HANDLE_VARS);
        if(res1==0 && res2==0 && res3==0)
            printf("    answer : (%s)(%s)%s\n", sol1,sol2,sol3);
            else printf("    can not extract answer\n");
        while (YAP_RestartGoal()) {
            printf("restart Success\n");
            arg1term=YAP_ArgOfTerm(1,YAP_GetFromSlot(sl));
            arg2term=YAP_ArgOfTerm(2,YAP_GetFromSlot(sl));
            arg3term=YAP_ArgOfTerm(3,YAP_GetFromSlot(sl));
            res1=YAP_WriteBuffer(arg1term, sol1, sz,YAP_WRITE_HANDLE_VARS);
            res2=YAP_WriteBuffer(arg2term, sol2, sz,YAP_WRITE_HANDLE_VARS);
            res3=YAP_WriteBuffer(arg3term, sol3, sz,YAP_WRITE_HANDLE_VARS);
            if(res1==0 && res2==0 && res3==0)
                printf("    answer : (%s)(%s)%s\n", sol1,sol2,sol3);
                else printf("    can not extract answer\n");
        }
        YAP_RecoverSlots(1);
        } else {
            printf("Failed\n");
            YAP_RecoverSlots(1);
            return 1;
    }
    return 0;
}


/**************************************************************
x    can pLadybug buy_rockets from pAcme ? (_ask_fact)
x    can pLadybug buy_rockets from Whom ? (_ask_whom)
x    can pLadybug What from pAcme ? (_ask_what)
x    can pLadybug What from Whom ? (_ask_what_whom)

x    Who can buy_rockets from pAcme ? (_ask_who)
**************************************************************/
// Whom.What <- ladybug
// isMember(ladybug, role(W1, W2), R)
static int _ask_what_whom(char *who, char *whom, char *aspect, char*what, char *whatwith)
{
    char str[100];

    printf("\n%s can what from whom... \n", who);
    printf("  Try again (yes) ? or'end' to finish : ");
    fflush(stdout);
    scanf("%s", str);
    if (strcmp(str, "end") == 0) {
        return 0;
    }

    YAP_Term arg[3];
    arg[0] = _make_term(who);
    arg[1] = _aspect_what_whom(who,aspect,what,whatwith);
    arg[2] = YAP_MkVarTerm();

    int res=_goal_call(arg);
    return res;
}

// pAcme.What <- ladybug
// isMember(ladybug, role(pAcme, W), R)
static int _ask_what(char *who, char* whom, char *aspect, char*what, char*whatwith) {
    char str[100];

    printf("\n%s can what from %s... \n", who, whom);
    printf("  Try again (yes) ? or'end' to finish : ");
    fflush(stdout);
    scanf("%s", str);
    if (strcmp(str, "end") == 0) {
        return 0;
    }

    /* outer part */
    YAP_Term arg[3];
    arg[0] = _make_term(who);
    arg[1] = _aspect_what(whom,aspect,what,whatwith);
    arg[2] = YAP_MkVarTerm();

    int res=_goal_call(arg);
    return res;
}


// W.rocket <- ladybug
// isMember(ladybug, role(W, buy_rockets), R)
static int _ask_whom(char *who, char*whom, char *aspect, char *what, char*whatwith)
{
    char str[100];

    printf("\n%s can %s from whom... \n", who, what);
    printf("  Try again (yes) ? or'end' to finish : ");
    fflush(stdout);
    scanf("%s", str);
    if (strcmp(str, "end") == 0) {
        return 0;
    }

    YAP_Term arg[3];
    arg[0] = _make_term(who);
    arg[1] = _aspect_whom(whom,aspect,what,whatwith);
    arg[2] = YAP_MkVarTerm();

    int res=_goal_call(arg);
    return res;
}
// Acme.rocket <- V
// isMember(V, role(pAcme, buy_rockets), R)
static int _ask_who(char *who,char *whom, char *aspect, char* what, char*whatwith)
{
    char str[100];
    printf("\nWho else can %s from %s... \n", what, whom);
    printf("  Try again (yes) ? or 'end' to finish : ");
    fflush(stdout);
    scanf("%s", str);
    if (strcmp(str, "end") == 0) {
        return 0;
    }

    YAP_Term arg[3];
    arg[0] = YAP_MkVarTerm();
    arg[1] = _aspect_fact(whom, aspect, what, whatwith);
    arg[2] = YAP_MkVarTerm();

    int res=_goal_call(arg);
    return res;
}

// Acme.rocket <- x 
// isMember(x, role(pAcme, buy_rockets), R)
static int _ask_fact(char *who,char *whom, char* aspect,
char *what, char*whatwith)
{

    YAP_Term arg[3];
    arg[0] = _make_term(who);
    arg[1] = _aspect_fact(whom, aspect, what, whatwith);
    arg[2] = YAP_MkVarTerm();

    int res=_goal_call(arg);
    return res;
}

/* wrapper used to call into yap */
static int Main_Wrapper() {

    if (YAP_FastInit(NULL) == YAP_BOOT_ERROR)
        YAP_Exit(1);

    if (YAP_RunGoal(YAP_MkAtomTerm(YAP_LookupAtom("source")))) {
        printf("calling source okay..\n");
        } else {
        printf("calling source failed..\n");
        YAP_Exit(1);
    }

    _loadFacts("rockets");
    _build_principal_tb("rockets.pl");

    char *aspect="role";

//    char *what="buy_rockets";
//    char *whatwith=NULL;
//    char *whom="pAcme";

    char *what="buy_flowers";
    char *whatwith="pBurpee";
    char *whom="pOsh";

    int res;
    for(;;) {
        char str[100];
        printf("\nWho can %s from %s... \n", what, whom);
        printf("  Enter a name(%s) or 'end' to finish : ",plist);
        fflush(stdout);
        scanf("%s", str);
        if (strcmp(str, "end") == 0) {
            break;
        }

        res=_ask_fact(str,whom,aspect,what,whatwith);

        if (res) {
            _ask_whom(str,whom,aspect,what,whatwith);
            _ask_what(str,whom,aspect,what,whatwith);
            _ask_what_whom(str,whom,aspect,what,whatwith);
            _ask_who(str,whom,aspect,what,whatwith);
        }
    }
    return res;
}

int main(int argc, char *argv[]) {
    return Main_Wrapper();
}
