
/****************************************************************
   utilities for porting/yap 
*****************************************************************/

#include "util.h"

void _showDB(int t)
{
    YAP_Term eterm;
     YAP_Term goal;
// trying different ways
    switch (t) {
      case 2:
        {
        printf("_showDB type 2\n");
        goal=YAP_MkAtomTerm(YAP_LookupAtom("listing"));
        break;
        }
      case 3:
        {
        printf("_showDB type 3\n");
        YAP_Atom listing = YAP_LookupAtom("listing");
        YAP_Functor lfunc=YAP_MkFunctor(listing, 0);
        goal = YAP_MkApplTerm(lfunc, 0, 0);
        break;
        }
      case 1:
      default:
        {
        printf("_showDB type 1/default\n");
        char lstr[10];
        strcpy(lstr,"listing");
        goal=YAP_ReadBuffer(lstr, &eterm);
        break;

        }
    }
    printf("calling db listing.. \n");

    long sl = YAP_InitSlot(goal);
    int res = YAP_RunGoal(goal);
    goal = YAP_GetFromSlot(sl);
    YAP_RecoverSlots(1);

    if (res) {
        printf("db listing ok.. \n");
    } else {
        printf("db listing bad.. \n");
        YAP_Exit(1);
    }
}

/**********************************************************************/
YAP_Term _buildFuncTermWith2Str(YAP_Functor func, char *str, char *str2)
{
    YAP_Term arg[2];
    arg[0] = YAP_MkAtomTerm(YAP_LookupAtom(str));
    arg[1] = YAP_MkAtomTerm(YAP_LookupAtom(str2));
    return YAP_MkApplTerm(func, 2, arg);
}

YAP_Term _buildFuncTermWith1Term(YAP_Functor func, YAP_Term arg)
{
    return YAP_MkApplTerm(func, 1, &arg);
}

YAP_Term _buildFuncTermWith2Var(YAP_Functor func)
{
    YAP_Term arg[2];
    arg[0] = YAP_MkVarTerm();
    arg[1] = YAP_MkVarTerm();
    return YAP_MkApplTerm(func, 2, arg);
//    return YAP_MkNewApplTerm(func, 2, arg);
}


/**********************************************************************/
void _addSomeRule()
{
    YAP_Term error;

    char bstr[]="newanc(X,Y) :- newparent(X,Y)";
    YAP_Term goal=YAP_ReadBuffer(bstr, &error);
    char *tmp=YAP_CompileClause(goal);
    if(tmp==NULL)
        printf("result of compile clause (no problem)\n");
        else printf("result of compile clause (%s)\n", tmp);
}

void _addSomeRule2()
{
    YAP_Term error;
    char xstr[]="funnyone(X,Y) :- A(X,Y), B(Y,this).";
    YAP_Term goal=YAP_ReadBuffer(xstr, &error);
    printf("calling adding a new clause.. \n");
 //   int res =YAP_RunGoal( goal );
    char *tmp=YAP_CompileClause(goal);
    if (tmp==NULL)
        printf("result of compile clause (no problem)\n");
        else printf("result of compile clause (%s)\n", tmp);
}

/**********************************************************************/
/* 
parent(bob, mary).
parent(jane, mary).
parent(mary, mark).
parent(paul, mark).
parent(mark, john).
*/

void _loadFacts(char *name)
{
    YAP_Term error;

printf("calling just listing.. \n");
YAP_Term tmp = YAP_MkApplTerm(YAP_MkFunctor(YAP_LookupAtom("listing"),0),0,0);
long safe_t = YAP_InitSlot(tmp); // have a safe pointer to term
int res2=YAP_RunGoalOnce(tmp); // run the goal
YAP_RecoverSlots(safe_t); 

    char *cstr= (char *) malloc(sizeof(char) * (strlen(name)+10));
    sprintf(cstr,"consult(%s)",name);
    YAP_Term goal=YAP_ReadBuffer(cstr, &error);
    printf("calling consult.. \n");
    int res =YAP_RunGoal( goal );
    free(cstr);
    if (res) {
        printf("consult ok.. \n");
    } else {
        printf("consult's bad.. \n");
        YAP_Exit(1);
    }
}

/* insert parent facts one at a time
parent(bob, mary).
parent(jane, mary).
parent(mary, mark).
parent(paul, mark).
parent(mark, john).
*/
void  _buildParentFacts()
{
// insert each statement one at a time
    YAP_Atom parent = YAP_LookupAtom("parent");
    YAP_Functor func = YAP_MkFunctor(parent, 2);
    YAP_Term fact = _buildFuncTermWith2Str(func, "bob","mary");

    YAP_Atom assert = YAP_LookupAtom("assert");
    YAP_Functor afunc = YAP_MkFunctor(assert, 1);
    YAP_Term goal = _buildFuncTermWith1Term(afunc, fact);
    int res = YAP_RunGoal(goal);
    fact = _buildFuncTermWith2Str(func, "jane","mary");
    goal = _buildFuncTermWith1Term(afunc, fact);
    res = YAP_RunGoal(goal);
    fact = _buildFuncTermWith2Str(func, "mary","mark");
    goal = _buildFuncTermWith1Term(afunc, fact);
    res = YAP_RunGoal(goal);
    fact = _buildFuncTermWith2Str(func, "paul","mark");
    goal = _buildFuncTermWith1Term(afunc, fact);
    res = YAP_RunGoal(goal);
    fact = _buildFuncTermWith2Str(func, "mark","john");
    goal = _buildFuncTermWith1Term(afunc, fact);
    res = YAP_RunGoal(goal);
    printf("done with _build_parent_clauses..\n");
}

/* insert rules one at a time
anc(X, Y):- parent(X, Y).
anc(X, Z):- parent(X, Y), anc(Y, Z).
*/
void  _buildAncesterRules()
{
    YAP_Term error;
    char xstr[]="anc(X, Y):- parent(X, Y)";
    char ystr[]="anc(X, Z):- parent(X, Y), anc(Y, Z)";
    printf("calling adding ancester rules.. \n");

    YAP_Term goal=YAP_ReadBuffer(xstr, &error);
    char *tmp=YAP_CompileClause(goal);
    if (tmp==NULL) {
        printf("adding first ancester ok.. \n");
    } else {
        printf("adding first ancester bad.. \n");
        YAP_Exit(1);
    }

    goal=YAP_ReadBuffer(ystr, &error);
    tmp=YAP_CompileClause(goal);
    if (tmp==NULL) {
        printf("adding second ancester ok.. \n");
    } else {
        printf("adding second ancester bad.. \n");
        YAP_Exit(1);
    }

}
