#include <stdio.h>
#include <string.h>
#include <Yap/YapInterface.h>

/*
   ?- anc(Y,mark).
Y = mary ? ;
Y = paul ? ;
Y = bob ? ;
Y = jane ? ;
no
*/

static YAP_Term _buildTermWith2Str(YAP_Functor func, char *str, char *str2)
{
    YAP_Term arg[2];
    arg[0] = YAP_MkAtomTerm(YAP_LookupAtom(str));
    arg[1] = YAP_MkAtomTerm(YAP_LookupAtom(str2));
    return YAP_MkApplTerm(func, 2, arg);
}

static YAP_Term _buildTermWith1Term(YAP_Functor func, YAP_Term fact)
{
    return YAP_MkApplTerm(func, 1, &fact);
}

static YAP_Term _buildTermWith2Var(YAP_Functor func)
{
    YAP_Term arg[2];
    arg[0] = YAP_MkVarTerm();
    arg[1] = YAP_MkVarTerm();
    return YAP_MkNewApplTerm(func, 2);
}

/* insert parent facts one at a time
parent(bob, mary).
parent(jane, mary).
parent(mary, mark).
parent(paul, mark).
parent(mark, john).
*/

static void _showDB()
{
    char lstr[]="listing";
    YAP_Term *eterm;

    YAP_Term goal=YAP_ReadBuffer(lstr, eterm);
    printf("calling listing.. \n");
    int res =YAP_RunGoal( goal );
    if (res) {
        printf("listing ok.. \n");
    } else {
        printf("listing's res is bad.. \n");
        YAP_Exit(1);
    }
}

/* wrapper used to call into yap */
static int Main_Wrapper() {
    YAP_Term arg[10];
    char str[100];
    char sol[100];
    int i = 0;
    int res;
    YAP_Term goal;
    YAP_Term *eterm;
    YAP_Functor func;


    if (YAP_FastInit(NULL) == YAP_BOOT_ERROR)
        YAP_Exit(1);

    if (YAP_RunGoal(YAP_MkAtomTerm(YAP_LookupAtom("source")))) {
        printf("calling source..\n");
        } else {
        printf("calling source failed..\n");
        YAP_Exit(1);
    }


    char cstr[]="consult(main2)";
    goal=YAP_ReadBuffer(cstr, eterm);
    printf("calling consult.. \n");
    res =YAP_RunGoal( goal );
    if (res) {
        printf("consult ok.. \n");
    } else {
        printf("consult's res is bad.. \n");
        YAP_Exit(1);
    }

    char xstr[]="assert( parent(john,kate)).";
    goal=YAP_ReadBuffer(xstr, eterm);
    printf("calling adding a new fact.. \n");
    res =YAP_RunGoal( goal );
    if (res) {
        printf("adding fact ok.. \n");
    } else {
        printf("adding fact's res is bad.. \n");
        YAP_Exit(1);
    }

    char bstr[]="newanc(X,Y) :- newparent(X,Y)";
    YAP_Term goalArgs=YAP_ReadBuffer(bstr, eterm);
    char *tmp=YAP_CompileClause(goalArgs);
    printf("result of compile clause (%s)\n", tmp);

/*
    char ystr[]="assert( anc2(X,Y) -> parent(X,Y) ).";
    goal=YAP_ReadBuffer(ystr, eterm);
    printf("calling adding a new clause.. \n");
    res =YAP_RunGoal( goal );
    if (res) {
        printf("adding clause ok.. \n");
    } else {
        printf("adding clause's res is bad.. \n");
        YAP_Exit(1);
    }

    char istr[]="anc2(X,Y)";
    char ostr[]=":-";
    char jstr[]="parent(X,Y)";
    YAP_Term head=YAP_ReadBuffer(istr, eterm);
    YAP_Term tail=YAP_ReadBuffer(jstr, eterm);
    YAP_Term op = YAP_ReadBuffer(ostr, eterm);
    YAP_Term g = YAP_MkPairTerm(head,tail);
    YAP_Term *goalArgs = YAP_ArraysOfTerm(g);
    YAP_Functor *goalFunctor = YAP_FunctorOfTerm(g);
    YAP_PredEntryPtr goalPred = YAP_FunctorToPred(goalFunctor);
    char *tmp=YAP_CompileClause(goalArgs);
    printf("result of compile clause (%s)\n", tmp);
*/


/*
    printf("calling adding a new clause.. \n");
    char ystr[1000];
    sprintf(ystr, "assert( anc2(X,Y) :- )");
    goal=YAP_ReadBuffer(ystr, eterm);
    res =YAP_RunGoal( goal );
    sprintf(ystr, "assert( parent(X,Y) )");
    goal=YAP_ReadBuffer(ystr, eterm);
    res =YAP_RunGoal( goal );
*/


/* this does not work 
    YAP_Functor func;
    YAP_Atom anc = YAP_LookupAtom("ancester");
    func = YAP_MkFunctor(anc, 2);
    YAP_Term head = _buildTermWith2Var(func);
    YAP_Atom parent = YAP_LookupAtom("parent");
    func = YAP_MkFunctor(parent, 2);
    YAP_Term tail = _buildTermWith2Var(func);
    YAP_Term rule = YAP_MkPairTerm(head,tail);

    printf("calling adding a new clause.. \n");
    char *tmp=YAP_CompileClause(rule);
    printf("result of compile clause (%s)\n", tmp);
*/

    _showDB();

//  to query : anc(Y, 'str')
    YAP_Atom anc = YAP_LookupAtom("anc");
    YAP_Functor afunc=YAP_MkFunctor(anc, 2);
    for (;;)
        {
        printf("\nEnter a name(mark|mary|bob|jane|john) or 'end' to finish : ");
        fflush(stdout);
        scanf("%s", str);

        if (strcmp(str, "end") == 0)
            break;

/** another try 
        char query_clause[100];
        sprintf(query_clause,"anc(C,%s)",str);

        YAP_Term qfunc=YAP_ReadBuffer(query_clause, eterm);
        YAP_StringToBuffer(qfunc, sol, 1000);
        printf("what is in qfunc(%s)\n", sol);
        YAP_Term arg0=YAP_ArgOfTerm(1,qfunc);
        int rc =YAP_RunGoal( goal );
        if (rc) {
           char sol[1000];
           printf("success in short\n");
            YAP_WriteBuffer(arg0, sol, 1000,YAP_WRITE_HANDLE_OPS); 
           printf("    C answer : %s\n", sol);
            while (YAP_RestartGoal()) {
                printf("Success\n");
                YAP_WriteBuffer(arg0, sol, 1000,YAP_WRITE_HANDLE_VARS);
                printf("    c answer : %s\n", sol);
            }
           } else {
              printf("failed in short\n");
        }
*/

 /* new, findall(C,clause,L) 
        char sol[1000];
        YAP_Term arg[3];
        YAP_Atom findall = YAP_LookupAtom("findall");
        YAP_Functor allfunc=YAP_MkFunctor(findall, 3);
        arg[0]=YAP_MkVarTerm();
        arg[1]=YAP_ReadBuffer(query_clause, eterm);
        arg[2]=YAP_MkVarTerm();
        goal = YAP_MkApplTerm(allfunc, 3, arg);
        int rc =YAP_RunGoal( goal );
        if (rc) {
            printf("Success\n");
            YAP_WriteBuffer(arg[0], sol, 1000,YAP_WRITE_HANDLE_VARS);
            printf("    C answer : %s\n", sol);
            YAP_WriteBuffer(arg[2], sol, 1000,YAP_WRITE_HANDLE_VARS);
            printf("    L answer : %s\n", sol);
            printf("query ok.. \n");
            while (YAP_RestartGoal()) {
                printf("Success\n");
            }
            } else {
                printf("query not ok.. \n");
        }
*/

        arg[0] = YAP_MkVarTerm();
        arg[1] = YAP_MkAtomTerm(YAP_LookupAtom(str));
        goal = YAP_MkApplTerm(afunc, 2, arg);
        long sl= YAP_InitSlot(goal);
        res = YAP_RunGoal(goal);
        if (res) {
            printf("Success\n");
            /* YAP_WriteBuffer(arg[0], sol, 100,YAP_WRITE_HANDLE_VARS); */
            YAP_Term argterm=YAP_ArgOfTerm(1,YAP_GetFromSlot(sl));
            YAP_WriteBuffer(argterm, sol, 100,YAP_WRITE_HANDLE_VARS);
            printf("    answer : %s\n", sol);
            while (YAP_RestartGoal()) {
                printf("Success\n");
                YAP_Term argterm=YAP_ArgOfTerm(1,YAP_GetFromSlot(sl));
                YAP_WriteBuffer(argterm, sol, 100,YAP_WRITE_HANDLE_VARS);
                printf("    answer : %s\n", sol);
            }
        } else printf("Failed\n");
        YAP_RecoverSlots(1);
        res=YAP_ShutdownGoal(TRUE);
    }

    return 0;
}

int main(int argc, char *argv[]) {
    return Main_Wrapper();
}
