
import java.io.*;
import java.util.*;

import net.deterlab.abac.*;

/**
 * Create various ABAC credentials
 */
public class SetupTest {

    static {
        System.loadLibrary("jABAC");
    }

    public static void main(String[] args) throws IOException {
        Context ctxt=new Context();

        ID acmeID=new ID("Acme",0);
        acmeID.id_write_cert("Acme_ID.pem");
        acmeID.id_write_privkey("Acme_private.pem");
        ctxt.load_id(acmeID);

        ID coyoteID=new ID("Coyote",0);
        coyoteID.id_write_cert("Coyote_ID.pem");
        coyoteID.id_write_privkey("Coyote_private.pem");
        ctxt.load_id(coyoteID);

        String acme=acmeID.id_keyid();
        String coyote=coyoteID.id_keyid();

        Role head = new Role(acme,"preferred_customer");
        Role tail = new Role(coyote);

        Attribute attr= new Attribute(head, 1800);
        attr.attribute_add_tail(tail);

        attr.attribute_bake();
        attr.attribute_write_cert("Acme_preferred_customer__Coyote_attr.der");

        ctxt.free_context_now();
        System.out.println("SetupTest okay.");
    }
}
